<template>
  <div class="buy-tokens">
    <div class="buy-tokens-form">
      <div>
        <div class="label">USD {{ $t('to_buy') }}</div>
        <el-input
          border
          v-model="form.amount"
          v-mask="{
            alias: 'numeric',
            groupSeparator: ',',
            autoGroup: true,
            digits: 2,
            allowMinus: false
          }"
        >
          <svg-icon name="$" width="24" height="24" slot="prefix" />
        </el-input>
      </div>
      <div>
        <Button
          variant="bg"
          border="primary"
          @click="createCharge"
          :disabled="form.amount <= 0"
        >
          {{ $t('buy') }}
        </Button>
      </div>
    </div>

    <Alert v-if="form.error" variant="danger">
      {{ form.error }}
    </Alert>

    <transition name="fade">
      <CoinbaseModal
        :charge-id="form.chargeId"
        v-if="form.showModal"
        @close="form.showModal = false"
      />
    </transition>
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive, useContext } from '@nuxtjs/composition-api'

import ElInput from '@/components/element/Input.vue'
import Button from '@/components/ui/Button.vue'
import Alert from '@/components/ui/Alert.vue'
import CoinbaseModal from '@/components/CoinbaseModal.vue'
import type { Charge } from '@/types/coinbase'

export default defineComponent({
  name: 'BuyTokens',
  components: {
    Alert,
    Button,
    ElInput,
    CoinbaseModal
  },
  setup(_, { root }) {
    const form = reactive({
      amount: 0,
      error: null as string | null,
      showModal: false,
      chargeId: null as string | null
    })

    const { app } = useContext()

    const createCharge = async () => {
      form.showModal = true
      try {
        const amount = form.amount.toString().replace(/,/g, '')
        const data = await root.$axios.$post<Charge>(
          '/api/payments/coinbase/create-charge',
          { amount },
          {
            headers: {
              authorization: `Bearer ${app.$api.auth.token}`
            }
          }
        )
        form.chargeId = data.code
        form.error = null
      } catch (e) {
        form.error = e?.response?.data?.message || e?.message || 'error'
        form.showModal = false
      }
    }

    return {
      form,
      createCharge
    }
  }
})
</script>

<style lang="scss" scoped>
.buy-tokens {
  .alert {
    margin-top: 1em;
  }

  .label {
    font-weight: bold;
    font-size: 18px;
    line-height: 23px;
    letter-spacing: 0.9px;
    color: #8591ad;
    text-transform: uppercase;
    margin-bottom: 20px;
    display: flex;
    align-items: center;
    &.center {
      justify-content: center;
    }

    svg {
      margin-left: 12px;
    }
  }

  &-form {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 30px 24px;
    align-items: flex-end;

    @media (min-width: 1199.98px) {
      grid-template-columns: 1fr 1fr;
    }
  }
}
</style>
